/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "event.h"
#include "assert/assert.h"
#include "ui/uitextbox.h"
#include "util/memory.h"

event_t eventCreate() {
  event_t event;
  return event;
}

void eventStart(const event_t *event) {
  assertNotNull(event, "Event cannot be NULL");
  assertTrue(event->count <= EVENT_ITEMS_MAX, "Event count exceeds maximum items");
  assertTrue(event->count > 0, "Event must have at least one item");

  switch(event->type) {
    case EVENT_TYPE_CONVERSATION: {
      assertTrue(event->items[0].type == EVENT_ITEM_TYPE_TEXT, "First item in conversation must be text");
      uiTextboxSetText(event->items[0].text.text);
      uiTextboxShow();
      break;
    }
    default:
      assertFalse(true, "Unknown event type");
  }
}