/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef enum {
  EVENT_TYPE_CONVERSATION,
} eventtype_t;

typedef enum {
  EVENT_ITEM_TYPE_TEXT
} eventitemtype_t;

typedef struct {
  const char_t *text;
} eventtext_t;

typedef struct {
  eventitemtype_t type;
  
  union {
    eventtext_t text;
  };
} eventitem_t;

#define EVENT_ITEMS_MAX 16

typedef struct {
  eventtype_t type;
  uint8_t count;
  eventitem_t items[EVENT_ITEMS_MAX];
} event_t;

/**
 * Creates a new event.
 */
event_t eventCreate();

/**
 * Starts a given event.
 */
void eventStart(const event_t *event);