/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "rpg/entity/entity.h"
#include "rpg/world/map.h"
#include "rpg/event/event.h"

const event_t TEST_MAP_NPC_TEST = {
  .type = EVENT_TYPE_CONVERSATION,
  .count = 1,
  .items = {
    {
      .type = EVENT_ITEM_TYPE_TEXT,
      .text = { .text = "Hello, player! How can I help you today?" }
    }
  },
};

/**
 * Initializes the test map.
 * This function sets up a test map with predefined dimensions.
 */
void testMapInit() {
  mapInit(10, 10);

  entity_t *ent = MAP.entities;
  entityInit(ent, ENTITY_TYPE_PLAYER);

  ent++;
  entityInit(ent, ENTITY_TYPE_NPC);
  entityPositionSet(ent, 5, 5);
  ent->npc.event = &TEST_MAP_NPC_TEST;
}

mapinfo_t TEST_MAP = {
  .name = "Test Map",
  .init = testMapInit
};