/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "uitextbox.h"
#include "assert/assert.h"
#include "util/memory.h"
#include "display/render.h"
#include "input.h"

uitextbox_t UI_TEXTBOX;

void uiTextboxInit() {
  memoryZero(&UI_TEXTBOX, sizeof(uitextbox_t));

  UI_TEXTBOX.width = RENDER_WIDTH;
  UI_TEXTBOX.height = 58;
  UI_TEXTBOX.x = 0;
  UI_TEXTBOX.y = RENDER_HEIGHT - UI_TEXTBOX.height;
}

void uiTextboxUpdate() {
  if(!UI_TEXTBOX.visible) return;

  if(inputWasPressed(INPUT_ACTION)) {
    UI_TEXTBOX.visible = false;
  }
}

void uiTextboxSetText(const char_t *text) {
  sprintf(UI_TEXTBOX.text, "%s", text);
}

void uiTextboxShow() {
  UI_TEXTBOX.visible = true;
}

void uiTextboxHide() {
  UI_TEXTBOX.visible = false;
}