/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

#define UI_TEXTBOX_TEXT_MAX_LENGTH 1024

typedef struct {
  bool_t visible;

  char_t text[UI_TEXTBOX_TEXT_MAX_LENGTH];

  uint16_t width, height;
  uint16_t x, y;
} uitextbox_t;

extern uitextbox_t UI_TEXTBOX;

/**
 * Initializes the UI textbox.
 */
void uiTextboxInit();

/**
 * Updates the UI textbox.
 */
void uiTextboxUpdate();

/**
 * Sets the text of the UI textbox.
 * 
 * @param text The text to set in the textbox.
 */
void uiTextboxSetText(const char_t *text);

/**
 * Shows the UI textbox.
 */
void uiTextboxShow();

/**
 * Hides the UI textbox.
 */
void uiTextboxHide();