/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "assert/assert.h"
#include "display/render.h"
#include <raylib.h>

#include "display/draw/drawentity.h"
#include "display/draw/drawui.h"

const uint16_t RENDER_WIDTH = 480;
const uint16_t RENDER_HEIGHT = 270;
Font FONT;

void renderInit() {
  InitWindow(RENDER_WIDTH, RENDER_HEIGHT, "Dusk");
  SetTargetFPS(60);

  FONT = LoadFontEx(
    "../assets/ark-pixel-font/12px/monospaced/ark-pixel-12px-monospaced-latin.otf",
    12, NULL, 0
  );
}

bool_t renderUpdate() {
  uint8_t x, y;
  char_t buffer[64];

  // End rendering?
  if(WindowShouldClose()) return false;

  BeginDrawing();
  ClearBackground(RAYWHITE);

  drawEntities();
  drawUITextbox();

  EndDrawing();

  return true;
}

void renderDispose() {
  CloseWindow();
}